stash: remove now superfluos help for "stash push"
[git.git] / git-rebase--merge.sh
blob06a4723d4db3db74ea17ace60d824e83cdee25e9
1 # This shell script fragment is sourced by git-rebase to implement
2 # its merge-based non-interactive mode that copes well with renamed
3 # files.
5 # Copyright (c) 2010 Junio C Hamano.
8 prec=4
10 read_state () {
11 onto_name=$(cat "$state_dir"/onto_name) &&
12 end=$(cat "$state_dir"/end) &&
13 msgnum=$(cat "$state_dir"/msgnum)
16 continue_merge () {
17 test -d "$state_dir" || die "$state_dir directory does not exist"
19 unmerged=$(git ls-files -u)
20 if test -n "$unmerged"
21 then
22 echo "You still have unmerged paths in your index"
23 echo "did you forget to use git add?"
24 die "$resolvemsg"
27 cmt=$(cat "$state_dir/current")
28 if ! git diff-index --quiet --ignore-submodules HEAD --
29 then
30 if ! git commit ${gpg_sign_opt:+"$gpg_sign_opt"} --no-verify -C "$cmt"
31 then
32 echo "Commit failed, please do not call \"git commit\""
33 echo "directly, but instead do one of the following: "
34 die "$resolvemsg"
36 if test -z "$GIT_QUIET"
37 then
38 printf "Committed: %0${prec}d " $msgnum
40 echo "$cmt $(git rev-parse HEAD^0)" >> "$state_dir/rewritten"
41 else
42 if test -z "$GIT_QUIET"
43 then
44 printf "Already applied: %0${prec}d " $msgnum
47 test -z "$GIT_QUIET" &&
48 GIT_PAGER='' git log --format=%s -1 "$cmt"
50 # onto the next patch:
51 msgnum=$(($msgnum + 1))
52 echo "$msgnum" >"$state_dir/msgnum"
55 call_merge () {
56 msgnum="$1"
57 echo "$msgnum" >"$state_dir/msgnum"
58 cmt="$(cat "$state_dir/cmt.$msgnum")"
59 echo "$cmt" > "$state_dir/current"
60 hd=$(git rev-parse --verify HEAD)
61 cmt_name=$(git symbolic-ref HEAD 2> /dev/null || echo HEAD)
62 eval GITHEAD_$cmt='"${cmt_name##refs/heads/}~$(($end - $msgnum))"'
63 eval GITHEAD_$hd='$onto_name'
64 export GITHEAD_$cmt GITHEAD_$hd
65 if test -n "$GIT_QUIET"
66 then
67 GIT_MERGE_VERBOSITY=1 && export GIT_MERGE_VERBOSITY
69 test -z "$strategy" && strategy=recursive
70 # If cmt doesn't have a parent, don't include it as a base
71 base=$(git rev-parse --verify --quiet $cmt^)
72 eval 'git-merge-$strategy' $strategy_opts $base ' -- "$hd" "$cmt"'
73 rv=$?
74 case "$rv" in
76 unset GITHEAD_$cmt GITHEAD_$hd
77 return
80 git rerere $allow_rerere_autoupdate
81 die "$resolvemsg"
84 echo "Strategy: $strategy failed, try another" 1>&2
85 die "$resolvemsg"
88 die "Unknown exit code ($rv) from command:" \
89 "git-merge-$strategy $cmt^ -- HEAD $cmt"
91 esac
94 finish_rb_merge () {
95 move_to_original_branch
96 if test -s "$state_dir"/rewritten
97 then
98 git notes copy --for-rewrite=rebase <"$state_dir"/rewritten
99 hook="$(git rev-parse --git-path hooks/post-rewrite)"
100 test -x "$hook" && "$hook" rebase <"$state_dir"/rewritten
102 say All done.
105 # The whole contents of this file is run by dot-sourcing it from
106 # inside a shell function. It used to be that "return"s we see
107 # below were not inside any function, and expected to return
108 # to the function that dot-sourced us.
110 # However, older (9.x) versions of FreeBSD /bin/sh misbehave on such a
111 # construct and continue to run the statements that follow such a "return".
112 # As a work-around, we introduce an extra layer of a function
113 # here, and immediately call it after defining it.
114 git_rebase__merge () {
116 case "$action" in
117 continue)
118 read_state
119 continue_merge
120 while test "$msgnum" -le "$end"
122 call_merge "$msgnum"
123 continue_merge
124 done
125 finish_rb_merge
126 return
128 skip)
129 read_state
130 git rerere clear
131 msgnum=$(($msgnum + 1))
132 while test "$msgnum" -le "$end"
134 call_merge "$msgnum"
135 continue_merge
136 done
137 finish_rb_merge
138 return
140 esac
142 mkdir -p "$state_dir"
143 echo "$onto_name" > "$state_dir/onto_name"
144 write_basic_state
146 msgnum=0
147 for cmt in $(git rev-list --reverse --no-merges "$revisions")
149 msgnum=$(($msgnum + 1))
150 echo "$cmt" > "$state_dir/cmt.$msgnum"
151 done
153 echo 1 >"$state_dir/msgnum"
154 echo $msgnum >"$state_dir/end"
156 end=$msgnum
157 msgnum=1
159 while test "$msgnum" -le "$end"
161 call_merge "$msgnum"
162 continue_merge
163 done
165 finish_rb_merge
168 # ... and then we call the whole thing.
169 git_rebase__merge